{$A+,B+,D-,E+,F+,I+,L+,N-,O+,R-,S+,V-}
unit initp2;

interface

uses
  crt, dos, overlay,
  myio,
  common;

procedure readp;
procedure initp1;
procedure init;

implementation

const
  openedyet:boolean=FALSE;


procedure readp;
var filv:text;
    d:astr;
    a,count:integer;

  function sc(s:astr; i:integer):char;
  begin
    s:=allcaps(s); sc:=s[i];
  end;

  procedure wpar(s:astr);
  begin
    TextAttr := Random(14)+1;

    writeln(' '+s);
  end;

  function atoi(s:astr):word;
  var i,code:integer;
  begin
    val(s,i,code);
    if code<>0 then i:=0;
    atoi:=i;
  end;

begin
  cursoron(FALSE); exteventtime:=0;
  answerbaud:=0; quitafterdone:=FALSE; returna:=FALSE; nightly:=FALSE;
  localioonly:=FALSE;

  a:=0;
  while (a<paramcount) do begin
    inc(a);
    if ((sc(paramstr(a),1)='-') or (sc(paramstr(a),1)='/')) then
      case sc(paramstr(a),2) of
        'B':answerbaud:=atoi(copy(paramstr(a),3,length(paramstr(a))-2));
        'E':if (length(paramstr(a))>=4) then begin
              d:=allcaps(paramstr(a));
              case d[3] of
                'E':exiterrors:=value(copy(d,4,length(d)-3));
                'N':exitnormal:=value(copy(d,4,length(d)-3));
              end;
            end;
        'K':Localioonly:=TRUE;
        'L': LocalIOOnly := TRUE;
        'N':nightly:=TRUE;
        'P':packbasesonly:=TRUE;
        'Q':quitafterdone:=TRUE;
        'X':exteventtime:=atoi(copy(paramstr(a),3,length(paramstr(a))-2));
      end;
  end;
  if (paramcount=0) then wpar('No Parameters Passed');
  if (exitnormal<>255) then wpar('Normal exit Errorlevel = '+cstr(exitnormal));
  if (exiterrors<>254) then wpar('Critical Error exit Errorlevel = '+cstr(exiterrors));
  if (nightly) then wpar('Execute Nightly Event');
  if (localioonly) then wpar('Local Logon ');
  if (answerbaud>0) then wpar('Answer incoming call at '+cstr(answerbaud)+' baud');
  if (exteventtime>0) then wpar('External event in '+cstr(exteventtime)+' minute(s)');
  if (quitafterdone) then wpar('Quit after user logoff');
  if (packbasesonly) then wpar('Pack message bases only');
  allowabort:=TRUE;
end;

procedure initp1;
var filv:text;
    evf:file of eventrec;
    fstringf:file of fstringrec;
    modemrf:file of modemrec;
    fidorf:file of fidorec;
    fp:file;
    wind:windowrec;
    v:verbrec;
    sx,sy,numread,i:integer;
    errs,npatch:boolean;
    s:astr;


  function existdir(fn:astr):boolean;
  var srec:searchrec;
  begin
    while (fn[length(fn)]='\') do fn:=copy(fn,1,length(fn)-1);
    findfirst(fexpand(sqoutsp(fn)),anyfile,srec);
    existdir:=(doserror=0) and (srec.attr and directory=directory);
  end;
    
  procedure abend(s:astr);
  begin
    writeln('*'+s+'*  --  Aborting');
    window(1,1,80,25); gotoxy(1,24); delay(3000);
    halt(exiterrors);
  end;

  procedure findbadpaths;
  var s,s1,s2:astr;
      i:integer;
  begin
    Npatch := FALSE;
    infield_out_fgrd:=15;
    infield_out_bkgd:=1;
    infield_inp_fgrd:=0;
    infield_inp_bkgd:=7;

    with systat do
      for i:=1 to 8 do begin
        case i of 1:s1:='GFILES'; 2:s1:='MSGS'; 3:s1:='MENUS'; 4:s1:='TFILES';
                  5:s1:='AFILES'; 6:s1:='LOG'; 7:s1:='TEMP'; 8:s1:='SWAP';
        end;
        case i of
          1:s:=gfilepath;  2:s:=msgpath;
          3:s:=menupath;   4:s:=tfilepath;
          5:s:=afilepath;  6:s:=trappath;
          7:s:=temppath;   8:s:=swappath;
        end;
        if (not existdir(s)) then begin
          cursoron(TRUE);
          writeln('');
          writeln('');
          writeln(s1+' path is currently "'+s+'"');
          writeln('This path is bad or missing.');
          repeat
            writeln('');
            s2:=s; writeln('New '+s1+' path: ',s2,60); s2:=allcaps(sqoutsp(s2));
            if (s=s2) or (s2='') then abend('Illegal pathname error')
            else begin
              if (s2<>'') then
                if (copy(s2,length(s2),1)<>'\') then s2:=s2+'\';
              if (existdir(s2)) then
                case i of
                  1:gfilepath:=s2;  2:msgpath:=s2;
                  3:menupath:=s2;   4:tfilepath:=s2;
                  5:afilepath:=s2;  6:trappath:=s2;
                  7:temppath:=s2;   8:swappath:=s2;
                end
              else begin
                writeln('');
                writeln('That path does not exist!');
              end;
            end;
          until (existdir(s2));
          cursoron(FALSE);
        end;
      end;
  end;

begin
  wantout:=TRUE;
  ldate:=daynum(date);
  ch:=FALSE; lil:=0; thisuser.pagelen:=23; buf:=''; chatcall:=FALSE;
  spd:=''; lastname:=''; ll:=''; chatr:=''; textcolor(0);
  cursoron(FALSE); textcolor(0);

  if (exist(start_dir+'\critical.err')) then begin
    assign(filv,start_dir+'\critical.err'); erase(filv);
    inc(systat.todayzlog.criterr);
    savesystat;
    wascriterr:=TRUE;
  end;

  findbadpaths;

  assign(fp,'msgtmp');
  {$I-} reset(fp); {$I+}
  if (ioresult=0) then begin close(fp); erase(fp); end;

  assign(sysopf,systat.trappath+'sysop.log');
  {$I-} append(sysopf); {$I+}
  if (ioresult<>0) then begin
    writeln(' Creating SYSOP.LOG ');
    rewrite(sysopf);
    writeln(sysopf);
  end;

  assign(sysopf1,systat.trappath+'slogxxxx.log');


  first_time:=TRUE;
  sl1(#3#7+'---------------> '+#3#5+'System booted on '+dat+#3#7+' <---------------');


  assign(modemrf,systat.gfilepath+'Modem.dat');
        reset(modemrf);
      read(modemrf,modemr); close(modemrf);

  assign(fstringf,systat.gfilepath+'string.dat');
   {$i-} reset(Fstringf);{$i+}
   if IoResult <> 0 then
    begin
    writeln(' Error reading STRING.DAT');
    delay(1000);
    end else
  read(fstringf,fstring); close(fstringf);

  assign(fidorf,systat.gfilepath+'Fidonet.dat');
  {$I-} reset(fidorf); {$I+}
  if (ioresult<>0) then begin
    writeln(' Creating FidoNet.dat');
    rewrite(fidorf);
    with fidor do begin
      zone:=0; net:=0; node:=0; point:=0;
      for i:=1 to 50 do origin[i]:=chr(0);
      origin:=copy(stripcolor(systat.bbsname),1,50);
      text_color:=1; quote_color:=3; tear_color:=9; origin_color:=5;
      skludge:=TRUE; sseenby:=TRUE; sorigin:=FALSE;
      scenter:=TRUE; sbox:=TRUE; mcenter:=TRUE;
      for i:=1 to sizeof(res) do res[i]:=0;
    end;
    write(fidorf,fidor);
  end else read(fidorf,fidor);
  close(fidorf);

  assign(sf,systat.gfilepath+'names.lst');
  {$I-} reset(sf); {$I+}
  if (ioresult<>0) then abend('Bad or missing NAMES.LST');
  close(sf);

  assign(uf,systat.gfilepath+'user.lst');
  reset(uf);
  if (filesize(uf)>1) then begin
    seek(uf,1);
    read(uf,thisuser);
  end else
    thisuser.slogseperate:=FALSE;
  reset(sf);
  if (systat.numusers<>filesize(sf)) then begin
    writeln(' Rebuilding Names List');
    systat.numusers:=filesize(sf);
    savesystat;
  end;
  close(sf);
  close(uf);

  assign(verbf,systat.gfilepath+'verbose.dat');
  {$I-} reset(verbf); {$I+}
  if (ioresult<>0) then rewrite(verbf);
  close(verbf); reset(verbf);
  {$I-} seek(verbf,0); read(verbf,v); {$I+}
  if (ioresult<>0) then begin
    writeln(' Creating VERBOSE.DAT');
    rewrite(verbf);
    v.descr[1]:='';
    write(verbf,v);
  end;
  close(verbf);

  assign(xf,systat.gfilepath+'protocol.dat');
  reset(xf); close(xf);

  new(events[0]);
  with events[0]^ do begin
    active:=nightly;
    description:='Back Door Nightly Events';
    etype:='D';
    execdata:='night.bat';
    busytime:=15;
    exectime:=240;  {* 4:00am *}
    busyduring:=TRUE;
    duration:=1;
    execdays:=127;  {* SMTWTFS *}
    monthly:=FALSE;
  end;
  assign(fp,systat.gfilepath+'events.dat');
  assign(evf,systat.gfilepath+'events.dat');
  {$I-} reset(fp,1); {$I+}
  if (ioresult<>0) then begin
    writeln(' Creating EVENTS.DAT');
    rewrite(evf); numevents:=1; new(events[1]);
    with events[1]^ do begin
      active:=FALSE;
      description:='A NEW BackDoor Event';
      etype:='D';
      execdata:='event.bat';
      busytime:=5;
      exectime:=0;
      busyduring:=TRUE;
      duration:=1;
      execdays:=0;
      monthly:=FALSE;
    end;
    write(evf,events[1]^);
  end else begin
    numevents:=0;
    repeat
      inc(numevents);
      new(events[numevents]);           (* DEFINE DYNAMIC MEMORY! *)
      blockread(fp,events[numevents]^,sizeof(eventrec),numread);
      if ((numread<>sizeof(eventrec)) and (numread<>0)) then npatch:=TRUE;
    until (numread<>sizeof(eventrec)) or (eof(fp));
  end;
  close(fp);
  if (npatch) then begin
    writeln(' Rebuilding EVENTS.DAT');
    rewrite(evf);
    for i:=1 to numevents do write(evf,events[i]^);
    close(evf);
  end;

  assign(fp,systat.gfilepath+'boards.dat');
  assign(bf,systat.gfilepath+'boards.dat');
  reset(fp,1); numboards:=0;
  repeat
    inc(numboards);
    blockread(fp,memboard,sizeof(boardrec),numread);
    if ((numread<>sizeof(boardrec)) and (numread<>0)) then npatch:=TRUE;
  until (numread<>sizeof(boardrec)) or (eof(fp));
  close(fp);
  if (npatch) then
  Begin
    writeln(' Errors in BOARDS.DAT '^G);
    delay(200);
    end;

  assign(fp,systat.gfilepath+'uploads.dat');
  assign(ulf,systat.gfilepath+'uploads.dat');
  reset(fp,1); maxulb:=-1;
  repeat
    inc(maxulb);
    blockread(fp,memuboard,sizeof(ulrec),numread);
    if ((numread<>sizeof(ulrec)) and (numread<>0)) then npatch:=TRUE;
  until (numread<>sizeof(ulrec)) or (eof(fp));
  close(fp);
  if (npatch) then
  Begin
    writeln(' Errors in UPLOADS.DAT'^G);
    delay(200);
    end;
  assign(smf,systat.gfilepath+'shortmsg.dat');

  cfo:=FALSE;

  if (openedyet) then removewindow(wind);
  textbackground(0); textcolor(7); clrscr;
end;

procedure init;
var rcode:integer;
begin
  if (daynum(date)=0) then begin
    clrscr;
    writeln('Please set the correct date & time.'^G^G^G^G^G^G^G^G^G^G);
    halt(exiterrors);
  end;

  hangup:=FALSE; incom:=FALSE; outcom:=FALSE;
  echo:=TRUE; doneday:=FALSE;
  checkbreak:=FALSE;
  slogging:=TRUE; trapping:=FALSE;
  readingmail:=FALSE; sysopon:=FALSE; inmsgfileopen:=FALSE;
  beepend:=FALSE;
  wascriterr:=FALSE;
  checksnow:=systat.cgasnow;
  directvideo:=not systat.usebios;

  readp;
  initp1;
  iport;

  if (exist('bbsstart.bat')) then shelldos(FALSE,'bbsstart.bat',rcode);
end;

end.
