{ This is the external Message packing routine                               }
{ Written by Mike Wilson                                                     }

Program MailPack;



Uses Crt,Common,MsgPack;

Const
   MailVersion = '0.01';

var
    ThisUser : UserRec;
    filv:text;
    SyStatF         : File of systatrec;
    evf:file of eventrec;
    fstringf:file of fstringrec;
    modemrf:file of modemrec;
    fidorf:file of fidorec;
    fp:file;
    v:verbrec;
    sx,sy,numread,i:integer;
    errs,npatch:boolean;
    s:astr;

procedure doshowpackbases;
var tempboard:boardrec;
    i:integer;
    b:boolean;

begin
  b:=(pause in thisuser.ac);
  thisuser.ac:=thisuser.ac-[pause];
  WRITELN;
writeln('                             Packing Message Bases                     ');
  writeln;
  reset(bf);

for i:=0 to filesize(bf)-1 do
 begin
    reset(bf);
    seek(bf,i);  { Seek Board Number }
    read(bf,tempboard);   { Read info }
    writeln(' Packing '+tempboard.name+' #'+cstr(i+1));
    packbase(tempboard.filename,tempboard.maxmsgs);
 end;
end;

procedure packallbases;
  var b:boolean;
  begin
    b:=(pause in thisuser.ac);
    thisuser.ac:=thisuser.ac-[pause];
    doshowpackbases;
    if (b) then thisuser.ac:=thisuser.ac+[pause];
  end;

Procedure ReadFiles;

Begin
    assign(systatf,'status.dat');
  {$I-} reset(systatf); {$I+}
  if (ioresult<>0) then
  begin
    TextColor(LightRed);
    writeln;
    writeln('Unable to find STATUS.DAT data file.  This file is absolutely');
    writeln('*REQUIRED* to even load the BBS.  If you cannot find your');
    writeln('STATUS.DAT data file, re-create one using the BDCreate.EXE package.');
    halt(254);
  end else
  begin
    {$I-} read(systatf,systat); {$I+}
    close(systatf);
  assign(sysopf,systat.trappath+'sysop.log');
  {$I-} append(sysopf); {$I+}
  if (ioresult<>0) then
  begin
    writeln('Bad or missing SYSOP.LOG - creating...');
    rewrite(sysopf);
    writeln(sysopf);
  end;
  assign(sysopf1,systat.trappath+'slogxxxx.log');

  assign(modemrf,systat.gfilepath+'Modem.dat');
  reset(modemrf);
  read(modemrf,modemr); close(modemrf);

  assign(fstringf,systat.gfilepath+'string.dat');
  {$i-} reset(Fstringf);{$i+}
   if IoResult <> 0 then
    begin
    writeln('Error reading String.DAT!');
    delay(1000);
    end else
  read(fstringf,fstring); close(fstringf);

  assign(fidorf,systat.gfilepath+'Fidonet.dat');
  {$I-} reset(fidorf); {$I+}
  if (ioresult<>0) then begin
  writeln('Bad or missing FidoNET.DAT - creating...');
  halt(1);
  end;
  read(fidorf,fidor);
  close(fidorf);

  assign(sf,systat.gfilepath+'names.lst');
  {$I-} reset(sf); {$I+}
  if (ioresult<>0) then write('Bad or missing NAMES.LST');
  close(sf);

  assign(uf,systat.gfilepath+'user.lst');
  reset(uf);
  if (filesize(uf)>1) then begin
    seek(uf,1);
    read(uf,thisuser);
  end else
    thisuser.slogseperate:=FALSE;
  reset(sf);
  if (systat.numusers<>filesize(sf)) then begin
    writeln('User count does not match with names list - fixing...');
    writeln('(NAMEFIX should be used, just to be safe)');
    systat.numusers:=filesize(sf);
  end;
  close(sf);
  close(uf);

  assign(verbf,systat.gfilepath+'verbose.dat');
  {$I-} reset(verbf); {$I+}
  if (ioresult<>0) then rewrite(verbf);
  close(verbf); reset(verbf);
  {$I-} seek(verbf,0); read(verbf,v); {$I+}
  if (ioresult<>0) then begin
    writeln('Bad or missing VERBOSE.DAT - creating...');
    halt(1);
  end;
  close(verbf);

  assign(fp,systat.gfilepath+'boards.dat');
  assign(bf,systat.gfilepath+'boards.dat');
  reset(fp,1); numboards:=0;
  repeat
    inc(numboards);
    blockread(fp,memboard,sizeof(boardrec),numread);
    if ((numread<>sizeof(boardrec)) and (numread<>0)) then npatch:=TRUE;
  until (numread<>sizeof(boardrec)) or (eof(fp));
  close(fp);
  if (npatch) then
    writeln(^G'Errors in BOARDS.DAT - run FIX for BOARDS.DAT...'^G);

  assign(smf,systat.gfilepath+'shortmsg.dat');
end;
end;

Procedure Before;

Begin
 ClrScr;
  writeln;
  writeln('MailPack v'+ MailVersion+' for BackDoor! Written By Mike Wilson ');
  writeln('Copyright 1991');
  writeln;
  writeln('Free for use in a NON-Commercial Environment');
End;


Procedure Done;

Begin
 writeln;
 writeln('Packing Complete!');
 writeln;
 delay(80);
end;


Procedure Params;


Begin
end;

  Begin
   ReadFiles;
    Before;
     if paramcount >0 then params;
     PackAllBases;
    Done;
  End.