(*****************************************************************************)
(*>                                                                         <*)
(*>  SYSOP2F .PAS -  Written by Eric Oman                                   <*)
(*>                                                                         <*)
(*>  SysOp functions: System Configuration Editor -- "F" command.           <*)
(*>                                                                         <*)
(*****************************************************************************)
{$A+,B+,D-,E+,F+,I+,L+,N-,O+,R-,S+,V-}
unit sysop2f;

interface

uses
  crt, dos, overlay,
  sysop2fa,
  common;

procedure pofilesconfig;
Procedure ShowBadFiles;  { Shows bad files }
Procedure MakeBAdFIle;   { This procedure makes the unacceptable uploads file }

implementation

Procedure MakeBAdFIle;   { This procedure makes the unacceptable uploads file }

Var
    BadFile : File of BadFileRecord;
    Reject : BadFileRecord;
    S : String[80];

Begin
{$I-} Assign(BadFile,systat.gfilepath+'badfile.dat');
      reset(Badfile); {$I+}
   if IOresult <> 0 then
      begin
       rewrite(BadFile);
      end;
Repeat
    Nl;
    Print('This option is good for files such as PkZip.Bat and Command.Com');
    Print('Press <CR> to end. ');
    prt('Enter filename that you do not wish to have uploaded : ');
    mpl(12);
    input(s,12);
   if (S='') or (S=' ') or (S= #0) then
   Begin
     Close(BadFile);
     exit;
    End else
     Begin
       Reject.FileName := AllCaps(S);
       Seek(BadFile,FileSize(BadFile));
       nl;
       print('Saving Record :'+Reject.FileName);
       write(BadFile,Reject);
       sysoplog(#3#4+'Added '+Reject.FileNAme+' to BadFile.Dat');
     end;
Until (hangup) or (s='');

  Close(BadFile);
End;


Procedure ShowBadFiles;
Var
 BadFile : File of BadFileRecord;
 Reject : BadFileRecord;
 Abort,NExt : Boolean;

 Begin
 Abort := False; Next := False;
 Cls;nl;
  printAcr(#3#5+' Unacceptable Uploads ',Abort,Next);
  printacr(#3#4+' =====================:====================================:============',abort,next);
  nl;
  Assign(BadFile,systat.gfilepath+'badfile.dat');
  reset(badfile);

  repeat
    read(Badfile,REject);
    printAcr(#3#2+Reject.FileName,Abort,Next);
  Until EOF(BadFIle) or (Abort) or (hangUp);
  Close(BadFile);
End;



procedure pofilesconfig;
var
    s:string[80];
    i:integer;
    c:char;
    b:byte;
    abort,next,done,changed:boolean;
begin
  done:=FALSE;
  repeat
    with systat do
    begin
      cls;
      sprint(#3#5+'File section configuration');
      nl;
      abort:=FALSE;
      printacr('A. Archive configuration',abort,next);
      printacr('B. Upload/download ratio          :'+aonoff(uldlratio,'Active','In-active'),abort,next);
      printacr('C. Auto file point compensation   :'+aonoff(fileptratio,'Active','In-active'),abort,next);
      printacr('D. File point compensation ratio  :'+cstr(fileptcomp)+' to 1',abort,next);
      printacr('E. Base file size per 1 file point:'+cstr(fileptcompbasesize)+'k',abort,next);
      printacr('F. Upload time refund percent     :'+cstr(ulrefund)+'%',abort,next);
      s:='G. "To-SysOp" file base           :';
      if (tosysopdir=255) then s:=s+'*None*' else s:=s+cstr(tosysopdir);
      printacr(s,abort,next);
      printacr('H. Auto-validate ALL files ULed?  :'+syn(validateallfiles),abort,next);
      printacr('I. Remote DOS re-direction device :'+systat.remdevice,abort,next);
      printacr('J. Max k-bytes allowed in TEMP\3\ :'+cstr(systat.maxintemp),abort,next);
      printacr('K. Min k-bytes to save for resume :'+cstr(systat.minresume),abort,next);
      PrintAcr('L. Set Unacceptable Uploads.',abort,next);
      nl;
      prt('Enter selection (A-K) [Q]uit : '); onek(c,'QABCDEFGHIJKL'^M);
      nl;
      case c of
        'Q':done:=TRUE;
        'A':poarcconfig;
        'B':uldlratio:=not uldlratio;
        'C':fileptratio:=not fileptratio;
        'D'..'G':begin
              if (c<>'G') then prt('Range (0-255)') else
                prt('Range (0-'+cstr(maxulb)+')  (255 to disable)');
              nl; prt('New value: '); mpl(3); ini(b);
              if (not badini) then
                case c of
                  'D':fileptcomp:=b;
                  'E':fileptcompbasesize:=b;
                  'F':ulrefund:=b;
                  'G':if ((b>=0) and (b<=maxulb)) or (b=255) then
                        tosysopdir:=b;
                end;
            end;
        'H':validateallfiles:=not validateallfiles;
        'I':begin
              sprint(#3#5+'This should be "GATE1" (or "GATE2", etc) if you have it.');
              sprint(#3#5+'OTHERWISE, it should be "COM1" (or "COM2", etc).');
              nl;
              prt('New device: '); mpl(10);
              inputwn(remdevice,10,changed);
            end;
        'J':begin
              prt('New max k-bytes: '); inu(i);
              if (not badini) then systat.maxintemp:=i;
            end;
        'K':begin
              prt('New min resume k-bytes: '); inu(i);
              if (not badini) then systat.minresume:=i;
            end;
        'L' : Begin
           If Exist(systat.gfilepath+'badfile.dat') then
             Begin
               if pynq('See list of Unacceptable Uploads [y/N]')
                  then ShowBadFiles;
               end;
                MakeBadFile;
           End;  { 'L' }

         end;    { Case }
    end;
  until (done) or (hangup);
end;

end.
